/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.Objects;

/**
 * Issue
 */
@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "class", visible = true )
@JsonSubTypes({
})

public class Issue {
  @JsonProperty("class")
  private String propertyClass = null;

  @JsonProperty("closed")
  private LocalDateTime closed = null;

  @JsonProperty("closed_by")
  private String closedBy = null;

  @JsonProperty("created")
  private LocalDateTime created = null;

  @JsonProperty("discussion")
  private IssueMessage discussion = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("subject")
  private Object subject = null;

  @JsonProperty("title")
  private String title = null;

  @JsonProperty("url")
  private String url = null;

  @JsonProperty("user")
  private Object user = null;

  public Issue propertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
    return this;
  }

   /**
   * The object class
   * @return propertyClass
  **/
  @ApiModelProperty(required = true, value = "The object class")
  public String getPropertyClass() {
    return propertyClass;
  }

  public void setPropertyClass(String propertyClass) {
    this.propertyClass = propertyClass;
  }

   /**
   * The issue closing date
   * @return closed
  **/
  @ApiModelProperty(value = "The issue closing date")
  public LocalDateTime getClosed() {
    return closed;
  }

   /**
   * The user who closed the issue
   * @return closedBy
  **/
  @ApiModelProperty(value = "The user who closed the issue")
  public String getClosedBy() {
    return closedBy;
  }

   /**
   * The issue creation date
   * @return created
  **/
  @ApiModelProperty(value = "The issue creation date")
  public LocalDateTime getCreated() {
    return created;
  }

  public Issue discussion(IssueMessage discussion) {
    this.discussion = discussion;
    return this;
  }

   /**
   * Get discussion
   * @return discussion
  **/
  @ApiModelProperty(value = "")
  public IssueMessage getDiscussion() {
    return discussion;
  }

  public void setDiscussion(IssueMessage discussion) {
    this.discussion = discussion;
  }

   /**
   * The issue identifier
   * @return id
  **/
  @ApiModelProperty(value = "The issue identifier")
  public String getId() {
    return id;
  }

  public Issue subject(Object subject) {
    this.subject = subject;
    return this;
  }

   /**
   * The issue target object
   * @return subject
  **/
  @ApiModelProperty(required = true, value = "The issue target object")
  public Object getSubject() {
    return subject;
  }

  public void setSubject(Object subject) {
    this.subject = subject;
  }

  public Issue title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The issue title
   * @return title
  **/
  @ApiModelProperty(required = true, value = "The issue title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

   /**
   * The issue API URI
   * @return url
  **/
  @ApiModelProperty(value = "The issue API URI")
  public String getUrl() {
    return url;
  }

  public Issue user(Object user) {
    this.user = user;
    return this;
  }

   /**
   * The issue author
   * @return user
  **/
  @ApiModelProperty(required = true, value = "The issue author")
  public Object getUser() {
    return user;
  }

  public void setUser(Object user) {
    this.user = user;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Issue issue = (Issue) o;
    return Objects.equals(this.propertyClass, issue.propertyClass) &&
        Objects.equals(this.closed, issue.closed) &&
        Objects.equals(this.closedBy, issue.closedBy) &&
        Objects.equals(this.created, issue.created) &&
        Objects.equals(this.discussion, issue.discussion) &&
        Objects.equals(this.id, issue.id) &&
        Objects.equals(this.subject, issue.subject) &&
        Objects.equals(this.title, issue.title) &&
        Objects.equals(this.url, issue.url) &&
        Objects.equals(this.user, issue.user);
  }

  @Override
  public int hashCode() {
    return Objects.hash(propertyClass, closed, closedBy, created, discussion, id, subject, title, url, user);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Issue {\n");

    sb.append("    propertyClass: ").append(toIndentedString(propertyClass)).append("\n");
    sb.append("    closed: ").append(toIndentedString(closed)).append("\n");
    sb.append("    closedBy: ").append(toIndentedString(closedBy)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    discussion: ").append(toIndentedString(discussion)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    subject: ").append(toIndentedString(subject)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

